// Author: Antonio Navarro
// URL: http://www.thingiverse.com/AntonioNav/
//
// This is a remix from:
// http://www.thingiverse.com/thing:57533
//
// Licencia: CC BY-SA 3.0
//  http://creativecommons.org/licenses/by-sa/3.0/
//

$fn=50;

//***********************************************************//
//***** Use 'to_print_part1' and 'to_print_part2' ***********//
//***** to generate stl files.                    ***********//

to_show();
//to_print();
//to_print_part1(); 
//to_print_part2(); 

module to_show(){
	color("orange"){
		rotate([0,90,0])
			xend_motor();
	}
	color("white"){
		rotate([0,90,0])
			varillas();
	}
//	color("green"){
		rotate([0,90,0])
			vertical_mount();
		horizontal_mount();
//	}
}

module to_print(){
	to_print_part1();
	translate([140,0,0])
		to_print_part2();	
}

module to_print_part1(){
	translate([0,0,2])
		rotate([0,180,0])
			vertical_mount();
}

module to_print_part2(){
	horizontal_mount();
}

module horizontal_mount(){
	alt=10;
	long=50;
	anch=17;
	diam=5;

	translate([-11,0,0])
	union(){
		difference(){
			translate([-long,0,0])
				cube([long,anch,alt]);
			translate([-long+2,2,-2])
				cube([long,anch-4,alt]);
			translate([-long+2,anch-5,0])
				cube([13,20,alt-2]);
		}
		difference(){
			union(){
				translate([-3,1.8,0])
					cube([8,2,alt+5]);
				translate([-3,anch-3.8,0])
					cube([8,2,alt+5]);
			}
			translate([-5.5,0,alt])
				cube([8,anch,10]);
		}
	}
	translate([-110,-25,0])
		chain_connect2();
	translate([-(long+11),0,0])
		cube([16,30,2.5]);

}

module vertical_mount(){
	alt=2;
	long=53;
	anch=17;
	diam=5;
	deep=12;

	difference(){
		hull(){
			cube([long,anch,alt]);
			translate([diam/2+long,diam/2,0])
				cylinder(d=diam, h=alt);
			translate([diam/2+long,anch-diam/2,0])
				cylinder(d=diam, h=alt);
		}
		holes();
		varillas();
	}
	translate([0,0,-(deep-alt)])
	difference(){
		union(){
			translate([-22.9,0,])
				cube([23.1,anch,deep]);
			translate([-31+8,9,0])
				chain_connect1();
		}
		translate([-24,1.8,alt])
			cube([25,anch-3.6,deep-(alt+2)]);
		translate([-10,1.8,-5])
			cube([11,anch-3.6,deep-(alt+2)]);
	}
	translate([-35+2,0,0])
		cube([12.2,anch,alt]);
}

module holes(){

	translate([12,3.5,0])
		hole(31, 15, 40);
	translate([1.5,10,0])
		hole(7, 20, 40);
	translate([1.5+45,10,0])
		hole(7, 20, 40);

}

module hole(lx=35, ly=10, lz=40){

	translate([lx/2,ly/2,0])
		cube([lx,ly,lz], center=true);
	
}

module varillas(){

	color("white"){
		translate([5,8.5,10])
			cylinder(d=8, h=30, center=true);
		translate([50,8.5,10])
			cylinder(d=8, h=30, center=true);
	}
}

module xend_motor(){

	translate([0,-5.5,0])
		rotate([0,0,180])
			translate([0,0,-33.5])
				rotate([-90,0,90])
					import("./Includes/x-end-motor_sin_z_endstop.stl");
}

module chain_connect2(){
	import("./Includes/Wire-chain-20mm-End2-sNi.stl");
}

module chain_connect1(){
	rotate([0,0,-90])
		translate([-57,-15,0])
			import("./Includes/Wire-chain-20mm-End1-sNi_fixed.stl");
}